--- old/usr/src/tools/cw/cw.c	2019-01-17 01:17:59.316698345 +0000
+++ new/usr/src/tools/cw/cw.c	2019-01-17 01:17:59.335909981 +0000
@@ -594,6 +594,28 @@
 	return (ret);
 }
 
+static boolean_t
+is_source_file(const char *path)
+{
+	char *ext = strrchr(path, '.');
+
+	if ((ext == NULL) || ((ext + 1) == '\0'))
+		return (B_FALSE);
+
+	ext += 1;
+
+	if ((strcasecmp(ext, "c") == 0) ||
+	    (strcmp(ext, "cc") == 0) ||
+	    (strcmp(ext, "i") == 0) ||
+	    (strcasecmp(ext, "s") == 0) ||
+	    (strcmp(ext, "cpp") == 0)) {
+		return (B_TRUE);
+	}
+
+	return (B_FALSE);
+}
+
+
 static void
 do_gcc(cw_ictx_t *ctx)
 {
@@ -659,10 +681,7 @@
 			    strcmp(arg + arglen - 3, ".il") == 0)
 				continue;
 
-			if (!in_output && arglen > 2 &&
-			    arg[arglen - 2] == '.' &&
-			    (arg[arglen - 1] == 'S' || arg[arglen - 1] == 's' ||
-			    arg[arglen - 1] == 'c' || arg[arglen - 1] == 'i'))
+			if (!in_output && is_source_file(arg))
 				c_files++;
 
 			/*
@@ -1366,7 +1385,6 @@
 
 	while (--ctx->i_oldargc > 0) {
 		char *arg = *++ctx->i_oldargv;
-		size_t arglen = strlen(arg);
 
 		if (strncmp(arg, "-_CC=", 5) == 0) {
 			newae(ctx->i_ae, strchr(arg, '=') + 1);
@@ -1374,10 +1392,7 @@
 		}
 
 		if (*arg != '-') {
-			if (!in_output && arglen > 2 &&
-			    arg[arglen - 2] == '.' &&
-			    (arg[arglen - 1] == 'S' || arg[arglen - 1] == 's' ||
-			    arg[arglen - 1] == 'c' || arg[arglen - 1] == 'i'))
+			if (!in_output && is_source_file(arg))
 				c_files++;
 
 			if (in_output == 0 || !(ctx->i_flags & CW_F_SHADOW)) {
@@ -1678,9 +1693,10 @@
 		(void) snprintf(buf, MAXPATHLEN, "%s/%s", ctx->i_tmpdir,
 		    dp->d_name);
 
-		if (strncmp(dp->d_name, ".", strlen(dp->d_name)) == 0 ||
-		    strncmp(dp->d_name, "..", strlen(dp->d_name)) == 0)
+		if (strcmp(dp->d_name, ".") == 0 ||
+		    strcmp(dp->d_name, "..") == 0) {
 			continue;
+		}
 
 		if (unlink(buf) == -1)
 			err(1, "failed to unlink temp file: %s", dp->d_name);
